/**
 * 
 */
package com.example.layouttest;


import java.io.Serializable;

import com.example.layouttest.event.ShowEditorsViewEvent;
import com.example.layouttest.event.AnotherViewSelectedEvent;
import com.example.layouttest.view.AppView;
import com.example.layouttest.view.EditorsView;
import com.example.layouttest.view.AnotherView;
import com.vaadin.event.EventRouter;
import com.vaadin.ui.Panel;

public class AppController implements Serializable {

    private static final long serialVersionUID = 1L;
    
    private EventRouter eventBus;
    private AppView appView;

    private EditorsView editorsView;
    private AnotherView anotherView;    
    /** Placeholder of the main view. */
    private Panel panel;
    
    public AppController(EventRouter eventBus) {
    	this.eventBus = eventBus;
    	this.appView = new AppView(eventBus);
    	editorsView = new EditorsView(eventBus);
    	anotherView = new AnotherView(eventBus);
    	init();
    }
    
    void init() {
        eventBus.addListener(AnotherViewSelectedEvent.class, this, "showAnotherView");
        eventBus.addListener(ShowEditorsViewEvent.class, this, "showEditorsView");
    } 

    public void go(Panel panel) {
        this.panel = panel;
        this.panel.setContent(appView);
        
        showEditorsView(null);
    }

    public void showEditorsView(ShowEditorsViewEvent event) {
    	editorsView.showEditorShortView();
    	appView.getMainPanel().setContent(editorsView);
    }
    
    public void showAnotherView(AnotherViewSelectedEvent event) {
    	appView.getMainPanel().setContent(anotherView);
    }     
}
