/**
 * 
 */
package com.example.layouttest.view;

import com.example.layouttest.event.AnotherViewSelectedEvent;
import com.vaadin.event.EventRouter;
import com.vaadin.ui.Button;
import com.vaadin.ui.HorizontalLayout;
import com.vaadin.ui.Label;
import com.vaadin.ui.Panel;
import com.vaadin.ui.VerticalLayout;
import com.vaadin.ui.Button.ClickEvent;
import com.vaadin.ui.Button.ClickListener;


@SuppressWarnings("serial")
public class EditorsView extends HorizontalLayout {
    
    EventRouter eventBus;
    
    private Button btnShortView;
    private Button btnTallView;
    private Button btnAnotherView;
    
    private Panel editorPanel;
    
    private EditorShortView editorShortView;
    private EditorTallView editorTallView;
    
	public EditorsView(EventRouter eventBus) {
    	this.eventBus = eventBus;
    	
        setWidth("100%");
        
        VerticalLayout vLayout = new VerticalLayout();
        addComponent(vLayout);
        
        vLayout.addComponent(new Label("EditorsView"));
        
        // Tree-view
        btnShortView = new Button("Short View");
        btnShortView.addListener(new ClickListener() {
			
			@Override
			public void buttonClick(ClickEvent event) {
				showEditorShortView();
			}
		});
        vLayout.addComponent(btnShortView);
        
        btnTallView = new Button("Tall View");
        btnTallView.addListener(new ClickListener() {
			
			@Override
			public void buttonClick(ClickEvent event) {
				showEditorTallView();
			}
		});
        vLayout.addComponent(btnTallView);
        
        btnAnotherView = new Button("Another View");
        btnAnotherView.addListener(new ClickListener() {
			
			@Override
			public void buttonClick(ClickEvent event) {
				EditorsView.this.eventBus.fireEvent(
						new AnotherViewSelectedEvent(this));
			}
		});
        vLayout.addComponent(btnAnotherView);
        
        // The editor panel
        this.editorPanel = new Panel();
        addComponent(this.editorPanel);
        
        // Child views
        editorShortView = new EditorShortView();
        editorTallView = new EditorTallView();
    }

    public Panel getEditorPanel() {
        return this.editorPanel;
    }
    
    public void showEditorShortView() {
    	editorPanel.setContent(editorShortView);
    }
    
    private void showEditorTallView() {
    	editorPanel.setContent(editorTallView);
    }
}
